"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const get_timer_1 = __importDefault(require("./get-timer"));
class PingTimer {
    constructor(keepalive, checkPing, variant) {
        this.destroyed = false;
        this.keepalive = keepalive * 1000;
        this.checkPing = checkPing;
        this.timer = (0, get_timer_1.default)(variant);
        this.reschedule();
    }
    clear() {
        if (this.timerId) {
            this.timer.clear(this.timerId);
            this.timerId = null;
        }
    }
    destroy() {
        this.clear();
        this.destroyed = true;
    }
    reschedule() {
        if (this.destroyed) {
            return;
        }
        this.clear();
        this.timerId = this.timer.set(() => {
            if (this.destroyed) {
                return;
            }
            this.checkPing();
            this.reschedule();
        }, this.keepalive);
    }
}
exports.default = PingTimer;
//# sourceMappingURL=PingTimer.js.map